# pylint: disable=C0301,C0326,C0305
"""Test correct filling correct paragraphs in issue"""
import pytest
from export_from_gitlab.viewsets import TeachersJson


@pytest.mark.parametrize("teachers,two_teachers", [("Сопрано", "Сопрано,Ильин")])
def test_issue_to_correct_teachers_find_correct_input(supply_json_to_test_find_by_teachers_correct_input, teachers, two_teachers):
    """Test find issue by one and two teachers with correct input"""
    test_issue_json_teachers_1 = TeachersJson(teachers)
    test_issue_json_teachers_2 = TeachersJson(two_teachers)

    teachers_list = test_issue_json_teachers_1.make_correct_json_by_teachers(supply_json_to_test_find_by_teachers_correct_input)
    two_teachers_list = test_issue_json_teachers_2.make_correct_json_by_teachers(supply_json_to_test_find_by_teachers_correct_input)
    assert str(teachers_list) == "[{'msid': 1, 'iid': 6, 'teachers': 'Сопрано', " \
                                 "'theme': 'если ли жизнь после докера', 'title': 'Сопрано: если ли жизнь после докера', " \
                                 "'description': {'Тема работы': 'Программное средство формирования расписания из тематических планов учебных дисциплин.', " \
                                 "'Аннотация': 'Разработка программного средства формирования расписания из тематических планов учебных дисциплин и пожеланий " \
                                 "преподавателей.', 'Цель дипломной работы': 'Разработка программного средства формирования расписания из тематических " \
                                 "планов учебных дисциплин и пожеланий преподавателей.', 'Основные вопросы и задачи, подлежащие разработке при выполнении дипломной работы': " \
                                 "['1. Аналитический обзор существующих алгоритмов и готовых решений для формирования расписания преподавателей.', " \
                                 "'1. Разработка архитектуры разрабатываемого программного средства формирования расписания.', " \
                                 "'1. Изучение формата файла тематического плана учебной дисциплины.', " \
                                 "'1. Реализация модуля для разбора файла тематического плана учебной дисциплины.', " \
                                 "'1. Анализ существующих особенностей расписания преподавателей *(например, день для филиала Квант должен быть выделен монопольно)*', " \
                                 "'1. Выработка формата для возможных пожеланий преподавателей *(ставить преподавателя только" \
                                 " в указанные дни, не ставить преподавателя в выбранные дни, учёт конференций, пожелания по первым/последним парам, субботам, максимальному " \
                                 "количеству занятий в день и разрывам пар первая-четвертая)*.', '1. Реализация модуля для разбора пожеланий преподавателей.', " \
                                 "'1. Реализация программного средства формирования расписания, позволяющего для заданного множества тематических планов и пожеланий " \
                                 "преподавателей формировать .xlsx-файл расписания.']}}]"

    assert str(two_teachers_list) == "[{'msid': 1, 'iid': 6, 'teachers': 'Сопрано', 'theme': 'если ли жизнь после докера', 'title': 'Сопрано: если ли жизнь после докера', " \
                                     "'description': {'Тема работы': 'Программное средство формирования расписания из тематических планов учебных дисциплин.', " \
                                     "'Аннотация': 'Разработка программного средства формирования расписания из тематических планов учебных дисциплин и пожеланий преподавателей.', " \
                                     "'Цель дипломной работы': 'Разработка программного средства формирования расписания из тематических планов учебных дисциплин и пожеланий" \
                                     " преподавателей.', 'Основные вопросы и задачи, подлежащие разработке при выполнении дипломной работы': " \
                                     "['1. Аналитический обзор существующих алгоритмов и готовых решений для формирования расписания преподавателей.', " \
                                     "'1. Разработка архитектуры разрабатываемого программного средства формирования расписания.', " \
                                     "'1. Изучение формата файла тематического плана учебной дисциплины.', " \
                                     "'1. Реализация модуля для разбора файла тематического плана учебной дисциплины.', " \
                                     "'1. Анализ существующих особенностей расписания преподавателей *(например, день для филиала Квант должен быть выделен монопольно)*', " \
                                     "'1. Выработка формата для возможных пожеланий преподавателей *(ставить преподавателя только в указанные дни, не ставить преподавателя " \
                                     "в выбранные дни, учёт конференций, пожелания по первым/последним парам, субботам, максимальному количеству занятий в день и разрывам " \
                                     "пар первая-четвертая)*.', '1. Реализация модуля для разбора пожеланий преподавателей.', " \
                                     "'1. Реализация программного средства формирования расписания, позволяющего для заданного множества тематических планов и пожеланий " \
                                     "преподавателей формировать .xlsx-файл расписания.']}}, {'msid': 2, 'iid': 6, 'teachers': 'Ильин', 'theme': 'если ли жизнь после докера', " \
                                     "'title': 'Ильин: если ли жизнь после докера', 'description': {'Тема работы': 'Программное средство формирования расписания из тематических " \
                                     "планов учебных дисциплин.', " \
                                     "'Аннотация': 'Разработка программного средства формирования расписания из тематических планов учебных дисциплин и пожеланий преподавателей.'," \
                                     " 'Цель дипломной работы': 'Разработка программного средства формирования расписания из тематических планов учебных дисциплин и пожеланий " \
                                     "преподавателей.', 'Основные вопросы и задачи, подлежащие разработке при выполнении дипломной работы': " \
                                     "['1. Аналитический обзор существующих алгоритмов и готовых решений для формирования расписания преподавателей.', " \
                                     "'1. Разработка архитектуры разрабатываемого программного средства формирования расписания.', " \
                                     "'1. Изучение формата файла тематического плана учебной дисциплины.', " \
                                     "'1. Реализация модуля для разбора файла тематического плана учебной дисциплины.', " \
                                     "'1. Анализ существующих особенностей расписания преподавателей *(например, день для филиала Квант должен быть выделен монопольно)*', " \
                                     "'1. Выработка формата для возможных пожеланий преподавателей *(ставить преподавателя только в указанные дни, не ставить преподавателя " \
                                     "в выбранные дни, учёт конференций, пожелания по первым/последним парам, субботам, максимальному количеству занятий в день и " \
                                     "разрывам пар первая-четвертая)*.', '1. Реализация модуля для разбора пожеланий преподавателей.', " \
                                     "'1. Реализация программного средства формирования расписания, позволяющего для заданного множества тематических " \
                                     "планов и пожеланий преподавателей формировать .xlsx-файл расписания.']}}]"


@pytest.mark.parametrize("teacher", [("Сопно")])
def test_issue_to_correct_teachers_find_incorrect_input(supply_json_to_test_find_by_teachers_correct_input, teacher):
    """Test find issue teachers with incorrect input"""
    test_issue_json_teachers = TeachersJson(teacher)

    teachers_list = test_issue_json_teachers.make_correct_json_by_teachers(
        supply_json_to_test_find_by_teachers_correct_input)

    assert teachers_list == []
